PATH_CUDD=/home/melatti/AssegnoRoma1/ricerca/software/cudd/cudd-3.0.0/cudd/
PATH_CUDD_LIB=/home/melatti/AssegnoRoma1/ricerca/software/cudd/cudd-3.0.0/cudd/.libs
if [ $# -lt 1 ]
then
    echo Give the dot filename
    exit
fi
file=$1
file_no_dots=`echo $file | tr "." "_"`

false=`grep 'label = "FALSE"' $file | tail -1 | awk '{print $1}' | tr -d '"'`
true=`grep 'label = "TRUE"' $file | tail -1 | awk '{print $1}' | tr -d '"'`

if [ "$false" == "" -o "$true" == "" ]
then
    echo Incomplete OBDD
    exit 1
fi

awk 'function dfs(x, visited){
    if (!(then_edge[x] in visited))
	dfs(then_edge[x], visited);
    if (!(else_edge[x] in visited))
	dfs(else_edge[x], visited);
    # print x, "t:"then_edge[x], "e:"else_edge[x], "v:"vars[x];
    # fflush();
    if ((then_edge[x] in visited) && (else_edge[x] in visited)) {
	print "  /* DBG: "x, vars[x], then_edge[x], else_edge[x]" */";
	print "  result["count"] = Cudd_bddIte(dd, vars[simple_lookup(names, \""vars[x]"\")], "visited[then_edge[x]]", "visited[else_edge[x]]");";
	print "  Cudd_Ref(result["count"]);";
	print "  Cudd_DebugCheck(dd);";
	visited[x] = "result["count"]";
	count++;
    }
}
BEGIN{
    start = 0;
    var = "";
}
{
    if (NF == 7 && $2$3$4 == "rank=same;") { 
	var = $6;
	all_vars = all_vars " " var;
    }
    if (($2 == "Trans" || $2 == "Init" || $2 == "Reachables") && NF > 4) { 
	start = 1;
	gsub("\"", " ");
	root = $3;
	var = "";
    }
    if (var != "" && $2$3$4 != "rank=same;" && $1 != "}") {
	gsub("\"", " ");
	vars[$1] = var;
	# print "/* DBG: "FNR, $1, var" */";
	# fflush();
    }
    if (start && NF > 1) {
	gsub("\"", " ");
	if (NF == 4)
	    then_edge[$1] = $3;
	else
	    else_edge[$1] = $3;
    }
}
END{
    visited["'$false'"] = "FALSE_BDD";
    visited["'$true'"] = "TRUE_BDD";
    # print "starting";
    # fflush();
    count = 0;
    dfs(root, visited);
    print "  /* VARS:"all_vars" */";
}' $file > $file.c.tmp

cat > $file.c <<EOF
#include <stdio.h>
#include <string.h>
#include "cudd.h"

#define ALL_VARS `tail -1 $file.c.tmp | awk '{print NF - 3}'`
#define ALL_OBDDS `tail -3 $file.c.tmp | head -1 | awk -F'[' '{print \$2}' | awk -F']' '{print \$1}'`

int simple_lookup(char **names, char *name)
{
  int i;
  for (i = 0; names[i]; i++) {
    if (strcmp(names[i], name) == 0)
      return i;
  }
  return i;
}

int main()
{
  DdManager *dd;
  DdNode *result[ALL_OBDDS + 1], *vars[ALL_VARS], *TRUE_BDD, *FALSE_BDD;
  FILE *fp;
  char *names[] = {`tail -1 $file.c.tmp | awk '{for (i = 3; i < NF; i++) printf("\""\$i"\", ");}'`(char *)0};
  char *onames[] = {"`grep -q Trans $file && echo "Trans" || { grep -q Init $file && echo "Init" || echo "Reach"; }`", (char *)0};
  int i;

  dd = Cudd_Init(0, 0, CUDD_UNIQUE_SLOTS, CUDD_CACHE_SLOTS, 0);
  Cudd_DebugCheck(dd);

  for (i = 0; i < ALL_VARS; i++) {
    vars[i] = Cudd_bddIthVar(dd, i);
    /*Cudd_Ref(vars[i]);*/
    Cudd_DebugCheck(dd);
  }
  TRUE_BDD = Cudd_ReadOne(dd);
  Cudd_Ref(TRUE_BDD);
  FALSE_BDD = Cudd_ReadLogicZero(dd);
  Cudd_Ref(FALSE_BDD);

EOF
cat $file.c.tmp >> $file.c
rm $file.c.tmp

cat  >> $file.c <<EOF
  fp = fopen("$file.c.dot", "w");
  Cudd_DumpDot (dd, 1, &result[ALL_OBDDS], names, &onames[0], fp);
  fclose(fp);
  printf("Support: %d\n", Cudd_SupportSize(dd, result[ALL_OBDDS]));
  Cudd_PrintInfo(dd, stdout);
  Cudd_PrintDebug(dd, result[ALL_OBDDS], Cudd_SupportSize(dd, result[ALL_OBDDS]), 1);
}
EOF

gcc -ggdb $file.c -I $PATH_CUDD -L $PATH_CUDD_LIB -lcudd -lm -o $file.c.exe || echo Errors in compiling $file.c
./$file.c.exe > $file.c.exe.log
echo dot -Tpdf $file.c.dot -o ${file_no_dots}_c.pdf
dot -Tpdf $file.c.dot -o ${file_no_dots}_c.pdf
echo ${file_no_dots}_c.pdf
